﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ArcGIS.Desktop.Framework;
using ArcGIS.Desktop.Framework.Contracts;
using ArcGIS.Desktop.Mapping;
using ArcGIS.Core.Data;
using ArcGIS.Desktop.Core;
using ArcGIS.Desktop.Core.Geoprocessing;
using ArcGIS.Desktop.Framework.Dialogs;

namespace AsyncFine
{
  internal class TestAsync : Button
  {
    protected override async void OnClick()
    {
      try
      {
        await FineGrainedMethodsAsync();
        var count = await MyOwnGoarseGrainedMethod();
        MessageBox.Show($@"Selection count {count}");
      }
      catch (Exception ex)
      {
        MessageBox.Show($@"Exception: {ex.Message}");
      }
      MessageBox.Show("OnClick is done");
    }

    private async Task FineGrainedMethodsAsync()
    {
      // run the methods below under QueuedTask
      await ArcGIS.Desktop.Framework.Threading.Tasks.QueuedTask.Run(() =>
      {
        // fine grained => call only from Queued Task
        var layers = MapView.Active.Map.FindLayers("TerritorialStats_3").OfType<FeatureLayer>().ToList();
        var parcels = layers[0] as FeatureLayer;
        QueryFilter qf = new QueryFilter()
        {
          WhereClause = "name = 'Waldshut, Landkreis'",
          SubFields = "*"
        };
        parcels.Select(qf, SelectionCombinationMethod.New);
        MapView.Active.ZoomToSelected(new TimeSpan(0, 0, 3));
      });
    }

    private Task<int> MyOwnGoarseGrainedMethod()
    {
      return ArcGIS.Desktop.Framework.Threading.Tasks.QueuedTask.Run<int>(() =>
      {
        // fine grained => call only from Queued Task
        var layers = MapView.Active.Map.FindLayers("TerritorialStats_3").OfType<FeatureLayer>().ToList();
        var parcels = layers[0] as FeatureLayer;
        QueryFilter qf = new QueryFilter()
        {
          WhereClause = "name = 'Berlin'",
          SubFields = "*"
        };
        var selection = parcels.Select(qf, SelectionCombinationMethod.New);
        MapView.Active.ZoomToSelected(new TimeSpan(0, 0, 3));
        return selection.GetCount();
      });
    }
  }
}
