﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ArcGIS.Desktop.Framework;
using ArcGIS.Desktop.Framework.Contracts;
using System.Windows.Input;

namespace HookingCommands
{
  internal class CreateBookmarkButton : Button
  {
    protected override void OnClick()
    {
      // ArcGIS Pro's Create button control DAML ID. 
      var commandId = DAML.Button.esri_mapping_createBookmark;
      // get the ICommand interface from the ArcGIS Pro Button
      // using command's plug-in wrapper
      // (note ArcGIS.Desktop.Core.ProApp can also be used)
      var iCommand = FrameworkApplication.GetPlugInWrapper(commandId) as ICommand;
      if (iCommand != null)
      {
        // Let ArcGIS Pro do the work for us
        if (iCommand.CanExecute(null))
          iCommand.Execute(null);
      }
    }
  }
}
